/* 
   Using FLTK with a GLUT Window embedded into FLTK Window

   g++ glut_subwindow.cxx -lfltk2 -lfltk2_gl -lfltk2_glut -lGL -lglut
*/

#include <fltk/DoubleBufferWindow.h>
#include <fltk/run.h>
#include <fltk/glut.h> 


void glut_timerCB(int id_timer)
{
  glutPostRedisplay();
  glutTimerFunc(20, glut_timerCB, id_timer);
}


void display(void)
{ 
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glutWireSphere(0.7,10,10);
  glutSwapBuffers();
}


int main(int argc, char **argv)
{
  fltk::DoubleBufferWindow win(640, 480, "glut test");
  win.show(); // glut will die unless parent window
  win.begin(); // this will cause Glut windows to be a child
  //With and without glutInit, we will get:
  //freeglut ERROR: Function <glutWireSphere> called without first calling 'glutInit'
    glutInit(&argc,argv);
    glutInitWindowSize(win.w()-20, win.h()-20);
    glutInitWindowPosition(10,10);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);
    glutCreateWindow("glut embedded window");
  win.end();

  glutDisplayFunc(display);
  glutTimerFunc(20,glut_timerCB,1); 
  
  fltk::run();
  return 0;
}

